$nav-height: 96px;

$canvasMaxWidth: 400px;
$canvasMaxHeight: 400px;

@function calc-vh($percentage) {
  @return calc((100vh - #{$nav-height}) * #{$percentage});
}

.dg.ac {
  z-index: 9999;
}

.noselect {
  -webkit-touch-callout: none; /* iOS Safari */
  -webkit-user-select: none; /* Safari */
  -khtml-user-select: none; /* Konqueror HTML */
  -moz-user-select: none; /* Old versions of Firefox */
  -ms-user-select: none; /* Internet Explorer/Edge */
  user-select: none; /* Non-prefixed version, currently
                                    supported by Chrome, Opera and Firefox */
}

html {
  scroll-behavior: smooth;
}



html,
body {
  width: 100vw;
  overflow-x: hidden;
  margin: 0;
  padding: 0;
}

body {
  background-color: #f5f1ee;
  color: #373535;
  font-family: "National";

  // shopify product page
  &.template-product {
    .product-container {
      height: calc(100vh - #{$nav-height});
      margin-top: $nav-height;
    }
  }
}

.prevent-scrolling{
  max-height: 100vh;
  overflow-y: hidden;
}

// body.with-nav {
//   .product-container {
//     height: calc(100vh - #{$nav-height});
//   }
// }

.big-button {
  font-size: 18px;
  font-weight: bold;
  min-width: 410px;
  text-align: center;
  padding: 39px 20px;
  text-transform: uppercase;
  border: 0 none;
  display: inline-block;
  border-radius: 50px;
  font-family: "National";

  span {
    margin-left: 20px;
  }
}

.small-button {
  font-size: 16px;
  font-weight: bold;
  text-align: center;
  padding: 14px 30px;
  border: 0 none;
  display: inline-block;
  border-radius: 30px;
  font-family: "National";

  &.pink {
    background-color: #e6d8d8;
    color: #a7383c;
  }
  &.green {
    background-color: #52665d;
    color: #f8fcfa;
  }
  &.brown {
    background-color: #e1cebf;
    color: #000;
  }
}

.customizer-loading {
  .product-container {
    .product-scene {
      .customizer-progress-bar {
      }
      .customizer-canvas-wrapper {
      }
    }
  }
}

.customizer-loaded {
  .product-container {
    .product-scene {
      .customizer-progress-bar {
        opacity: 0;
      }
      .customizer-canvas-wrapper {
        opacity: 1;
        transition: opacity 700ms;
      }
    }
  }
}

.product-container {
  position: relative;
  display: flex;
  flex-direction: column;

  @media screen and (min-width: 800px) {
    flex-direction: row;
  }

  .product-scene {
    transition: transform 0.5s;
    position: relative;
    // height: calc(100vh - #{$nav-height});

    @media screen and (min-width: 800px) {
      min-width: 50vw;
    }

    .customizer-progress-bar {
      display: flex;
      justify-content: center;
      align-items: center;
      position: absolute;
      top: 0;
      left: 0;
      width: 100%;
      height: 100%;
      opacity: 1;
      transition: all 500ms;

      svg {
        * {
          fill: #000;
        }
      }
    }

    .slider-wrapper {
      width: calc(100% - 60px);
      margin: 25px auto 0;
      display: flex;
      justify-content: space-between;

      @media screen and (min-width: 800.1px) {
        width: 100%;
      }
    }

    .slider-controls {
      position: relative;
      display: inline-block;
      background: transparent;
      border: 0 none;
      outline: 0 none;
      margin: 0;
      padding: 0;
      cursor: pointer;
      opacity: 0.8;

      &,
      img {
        width: 28px;
        height: 28px;
      }
      &:hover {
        opacity: 1;
      }
    }

    $track-color: #e1cebf;
    $thumb-color: #ffffff;

    $thumb-radius: 50%;
    $thumb-height: 20px;
    $thumb-width: 20px;
    $thumb-shadow-size: 1px;
    $thumb-shadow-blur: 1px;
    $thumb-shadow-color: #111;
    $thumb-border-width: 0;
    $thumb-border-color: #fff;

    $track-width: calc(100% - 20px);
    $track-height: 2px;
    $track-shadow-size: 0;
    $track-shadow-blur: 0;
    $track-shadow-color: #222;
    $track-border-width: 0;
    $track-border-color: black;

    $track-radius: 0;
    $contrast: 5%;

    @mixin shadow($shadow-size, $shadow-blur, $shadow-color) {
      box-shadow: $shadow-size $shadow-size $shadow-blur $shadow-color, 0px 0px $shadow-size lighten($shadow-color, 5%);
    }

    @mixin track() {
      width: $track-width;
      height: $track-height;
      cursor: pointer;
      animate: 0.2s;
    }

    @mixin thumb() {
      @include shadow($thumb-shadow-size, $thumb-shadow-blur, $thumb-shadow-color);
      border: $thumb-border-width solid $thumb-border-color;
      height: $thumb-height;
      width: $thumb-width;
      border-radius: $thumb-radius;
      background: $thumb-color;
      cursor: pointer;
    }

    .slider-wrapper {
      input[type="range"] {
        -webkit-appearance: none;
        margin: $thumb-height/2 10px;
        width: $track-width;
        background: transparent;

        &:focus {
          outline: none;
        }

        &::-webkit-slider-runnable-track {
          @include track();
          // @include shadow($track-shadow-size, $track-shadow-blur, $track-shadow-color);
          background: $track-color;
          border-radius: $track-radius;
          border: $track-border-width solid $track-border-color;
        }

        &::-webkit-slider-thumb {
          @include thumb();
          -webkit-appearance: none;
          margin-top: ((-$track-border-width * 2 + $track-height) / 2) - ($thumb-height / 2);
        }

        &:focus::-webkit-slider-runnable-track {
          // background: lighten($track-color, $contrast);
        }

        &::-moz-range-track {
          @include track();
          // @include shadow($track-shadow-size, $track-shadow-blur, $track-shadow-color);
          background: $track-color;
          border-radius: $track-radius;
          border: $track-border-width solid $track-border-color;
        }
        &::-moz-range-thumb {
          @include thumb();
        }

        &::-ms-track {
          @include track();
          background: transparent;
          border-color: transparent;
          border-width: $thumb-width 0;
          color: transparent;
        }

        &::-ms-fill-lower {
          background: darken($track-color, $contrast);
          border: $track-border-width solid $track-border-color;
          border-radius: $track-radius * 2;
          // @include shadow($track-shadow-size, $track-shadow-blur, $track-shadow-color);
        }
        &::-ms-fill-upper {
          background: $track-color;
          border: $track-border-width solid $track-border-color;
          border-radius: $track-radius * 2;
          // @include shadow($track-shadow-size, $track-shadow-blur, $track-shadow-color);
        }
        &::-ms-thumb {
          @include thumb();
        }
        &:focus::-ms-fill-lower {
          // background: $track-color;
        }
        &:focus::-ms-fill-upper {
          // background: lighten($track-color, $contrast);
        }
      }
    }

    .customizer-canvas-wrapper {
      width: 100%;
      position: relative;
      opacity: 0;

      .bg-circles {
        position: absolute;
        top: 0;
        bottom: 0;
        left: 0;
        right: 0;
        margin: auto;
        width: 40vw;
        height: 40vw;
        background-image: url("../localhost/wine/CIRCLES_DECOR.png");
        background-repeat: no-repeat;
        background-size: 40vw;
        background-position: center;
        z-index: -1;
        transition: opacity 0.5s;
      }

      .product-plus-sign {
        cursor: pointer;
        text-align: center;
        font-size: 16px;
        display: block;
        position: absolute;
        // display: none;
        opacity: 0;
        visibility: hidden;
        transition: 0.3s all;

        width: 40px;
        height: 40px;
        line-height: 40px;
        left: calc(50% - 110px);
        top: calc(50% - 130px);

        img {
          width: 40px;
          height: 40px;
        }

        svg {
          path {
            fill: #a7383c;
          }
        }
      }
    }

    .product-label {
      visibility: hidden;
      opacity: 0;
      position: absolute;
      top: 0;
      left: 0;
      width: 100%;
      height: calc-vh(1);
      outline: rgba(#373535, 0.5);

      @media screen and (min-width: 800.1px) {
        min-height: 660px;
        overflow-y: auto;
      }

      .push-up {
        width: $canvasMaxWidth;
        max-width: 90vw;
        display: flex;
        flex-direction: column;
        margin: 0 auto;
      }

      .label-customizer-wrapper {
        display: flex;
        justify-content: center;
        align-items: center;
        height: calc(100% - 100px);

        &.blank {
          .blank-canvas-placeholder {
            display: flex;
          }
        }

        .grid-on-top {
          content: "";
          position: absolute;
          background-size: contain;
          max-width: $canvasMaxWidth;
          max-height: $canvasMaxHeight;
          width: 100%;
          height: 100%;
          pointer-events: none;
          opacity: 0;
          transition: opacity 0.1s;
        }

        .blank-canvas-placeholder {
          width: $canvasMaxWidth;
          height: $canvasMaxHeight;
          max-width: 90vw;
          max-height: 90vw;
          display: none; // or flex
          flex-direction: column;
          justify-content: center;
          align-items: center;
          position: absolute;
          z-index: 3;
          background-color: #fff;
          color: #000;
          border: 1px solid rgba(0, 0, 0, 0.1);

          img {
            width: 50px;
            height: 50px;
          }
          .upload-title {
            font-size: 28px;
            line-height: 1.8;
          }
          .upload-info {
            font-size: 18px;
            line-height: 1.2;
          }
        }

        #label-customizer {
          width: $canvasMaxWidth;
          max-width: 90vw;
          max-height: 90vw;
          background: rgba(0, 0, 0, 0.1);
          display: flex;
          flex-direction: column;
          justify-content: center;
          align-items: center;
          padding: 0;

          canvas {
            max-width: $canvasMaxWidth;
            max-height: $canvasMaxHeight;
            outline: 1px dotted rgba(0, 0, 0, 0.1);
          }
        }

        #label-canvas{
          // background-color: white;
        }
        #label-mask-canvas{
          // opacity: 0;
        }
      }
    }

    .product-preview,
    .product-button-wrapper {
      visibility: hidden;
      opacity: 0;
      width: 100%;
      position: absolute;
      bottom: 20px;
      display: flex;
      justify-content: center;
      flex-direction: column;
      align-items: center;

      .small-button {
        width: 320px;
        &:last-of-type {
          margin-top: 20px;
        }
      }

      &.ON_TOP {
        bottom: inherit;
        top: 10px;
      }

      .product-button-wrapper,
      .product-button-wrapper {
        button {
          padding: 10px 20px;
          font-size: 16px;
        }
      }
    }
  }

  .product-info {
    width: calc(100% - 40px);
    padding: 0 20px 25px;
    transition: transform 0.5s;

    @media screen and (min-width: 800.1px) {
      width: 50%;
      padding: 50px 40px;
    }

    .product-title {
      font-family: "Optima";
      font-size: 48px;
      font-weight: normal;
      margin: 0;
      z-index: 2;
      position: relative;
    }
    #additionalMarginOnMobile {
      display: none;
      height: 21px;
      content: "";

      @media screen and (max-width: 800px) {
        display: block;
      }
    }
    .product-description {
      font-size: 16px;
      color: #675d56;
      line-height: 1.2;
      margin-bottom: 42px;

      @media screen and (min-width: 800.1px) {
        width: 75%;
      }
    }

    .product-variants-wrapper {
      font-size: 18px;
      font-weight: bold;
      margin-top: 40px;
      margin-bottom: 12px;
      // width: 350px;
      // display: flex;
      // justify-content: space-around;

      .variants-list {
        display: none;
        flex-direction: row;
        &.visible {
          display: flex;
        }
      }

      ul {
        list-style-type: none;
        display: flex;
        flex-direction: column;
        display: inline-block;
        margin: 0;
        padding: 0;

        li {
          border-radius: 50px;
          padding: 27px 0;
          min-width: 172px;
          text-align: center;
          line-height: 1;
          display: inline-block;
          color: #374a62;
          background-color: transparent;
          margin-left: 24px;
          cursor: pointer;
          font-family: "National";

          &:first {
            margin-left: 0;
          }

          &.active {
            background-color: #d6d9dd;
          }
        }
      }
    }

    .product-customize-button {
      margin: 24px 0;
      .big-button {
        text-transform: capitalize;
        background-color: #e1cebf;
        color: #373535;
      }
    }

    .product-add-cart-button {
      margin: 24px 0;
      .big-button {
        background-color: #557567;
        color: #f8fcfa;
      }
    }
  }
}

.customizer-step-1,
.customizer-step-2 {
  @media screen and (min-width: 800.1px) {
    .product-container {
      .product-info {
        transform: translateX(100%);
      }
      .product-scene {
        transform: translateX(50%);
      }
    }
  }
  @media screen and (max-width: 800px) {
    #site-header,
    nav {
      display: none !important;
    }
    body.template-product .product-container {
      // margin-top: 0 !important;
    }
    .product-info {
      opacity: 0;
      visibility: hidden;
    }
  }
}

.customizer-step-1 {
  .product-container {
    .product-scene {
      .product-preview {
        visibility: visible;
        opacity: 1;
      }
      .customizer-canvas-wrapper .product-plus-sign {
        // display: block;
        opacity: 1;
        visibility: visible;
      }
    }
  }

  .bg-circles {
    opacity: 0;
    visibility: hidden;
    transition: 0.5s;
  }
}

.customizer-step-2 {
  max-height: 100vh;
  overflow: hidden;

  .product-container .product-scene {
    .product-button-wrapper,
    .product-label {
      visibility: visible;
      opacity: 1;
    }
    .customizer-canvas-wrapper .product-plus-sign {
      opacity: 0;
      visibility: hidden;
      transition: 0s all;
    }
  }

  #three-canvas {
    opacity: 0;
    visibility: hidden;
    transition: 0.5s;
  }

  #label-customizer {
    @media screen and (min-width: 800.1px) {
      margin-top: 30px;
    }
  }

  .bg-circles {
    opacity: 0;
    visibility: hidden;
    transition: 0.5s;
  }

  &.dragging {
    .product-container .product-scene .product-label .label-customizer-wrapper .grid-on-top {
      opacity: 1;
    }
  }
}

#site-header,
nav {
  position: fixed;
  top: 0;
  left: 0;
  width: 100vw;
  height: $nav-height;
  display: flex;
  justify-content: space-between;
  background-color: #f5f1ee;
  border-bottom: 2px solid #e4e0dd;
  z-index: 99;

  .nav-logo {
  }

  .nav-left,
  .nav-right {
    display: flex;
    height: 100%;
    align-items: center;
    margin: 0 50px;
    width: calc(50% - 50px);
  }
  .nav-left {
    justify-content: flex-start;
  }
  .nav-right {
    justify-content: flex-end;

    a {
      font-size: 18px;
      font-family: "Optima";
      margin-right: 72px;
      color: #373535 !important;
      text-decoration: none !important;

      &:last-of-type {
        margin-right: 0;
      }
    }

    .cart {
      position: relative;
      width: 42px;
      height: 42px;

      .cart-bg {
        width: 42px;
        height: 42px;
      }
      .cart-icon {
        position: absolute;
        width: 14px;
        height: 18px;
        top: calc(50% - 18px / 2);
        left: calc(50% - 14px / 2);
      }
      .cart-with-items {
        position: absolute;
        width: 17px;
        height: 17px;
        top: calc(17px / -4);
        right: calc(17px / -4);
      }
    }
  }
}

.dg.ac.dotStyle1 {
  top: $nav-height !important;
}

@media screen and (max-width: 800px) {
  $mobile-nav-height: 60px;

  .customizer-step-1,
  .customizer-step-2 {
    #site-header,
    nav {
      // display: none !important;
    }
  }

  .customizer-step-1,
  .customizer-step-2 {
    max-height: 100vh;
    overflow-y: hidden;
  }

  body.template-product .product-container {
    margin-top: $mobile-nav-height;
  }

  body.template-product .product-container {
    // height: calc(100vh - $mobile-nav-height);
    height: inherit;
  }

  #site-header .nav-right,
  nav .nav-right {
    width: 50%;
    a:not(.cart) {
      display: none;
    }
  }

  #site-header .nav-left,
  nav .nav-left {
    width: 50%;
  }

  #site-header,
  nav {
    height: $mobile-nav-height;
    padding: 0 20px !important;

    .nav-left,
    .nav-right {
      margin: 0;
    }

    .nav-right {
      padding-right: 10px;
    }
  }

  #site-header .nav-left {
    justify-content: center;
  }

  .product-container {
    .product-info {
      display: flex;
      justify-content: center;
      width: calc(100vw - 60px);
      // padding: 25px 20px;
      margin: 0 auto;
      flex-direction: column;

      .product-title,
      .product-description {
        text-align: center;
      }
      .product-description {
        margin-bottom: 0;
      }
      .product-customize-button,
      .product-add-cart-button {
        display: flex;
        flex-direction: column;
        justify-content: center;
        margin: 15px 0;

        .big-button {
          min-width: 250px;
          width: 100%;
          margin: 0 auto;
          font-size: 16px;
          padding: 20px 16px;
        }
      }
      .product-variants-wrapper ul li {
        padding: 14px 0;
        min-width: 120px;
        margin-left: 6px;
      }
    }

    .product-scene {
      &:before,
      &:after {
        position: absolute;
        top: 0;
        display: block;
        content: "";
        width: 40px;
        height: 100%;
        z-index: 2;
      }

      &:before {
        left: 0;
      }
      &:after {
        right: 0;
      }

      .product-label {
        width: 100vw;
        height: calc(100vh - #{$mobile-nav-height});

        .push-up {
          // height: calc(100vh - 40px);
          position: fixed;
          width: 100vw;
          max-width: inherit;
          top: 40px;
        }

        .label-customizer-wrapper {
          position: relative;
          max-width: $canvasMaxWidth;
          max-height: $canvasMaxHeight;
          overflow: hidden;
          // height: calc(100vh - 200px);
          width: calc(100vw - 60px);
          margin: 0 auto 20px;
          align-items: flex-start;
          justify-content: space-between;

          #label-customizer {
            width: calc(100vw - 60px);
            height: calc(100vw - 60px);
            margin: 0;
            padding: 0;
            max-width: inherit;
            max-height: inherit;
            canvas {
              width: calc(100vw - 60px);
              height: calc(100vw - 60px);
            }
          }
        }
      }

      .product-button-wrapper {
        display: flex;
        flex-direction: column;
        justify-content: space-between;
        position: fixed;
        bottom: 20px;
        align-items: center;
        z-index: 3;
      }

      .small-button {
        width: 300px;
        max-width: 90vw;

        &.margin-bot {
          margin-bottom: 20px;
        }
      }

      .product-preview {
        bottom: 20px;
        position: fixed;
      }
    }
  }

  .product-container .product-info .product-variants-wrapper .variants-list {
    justify-content: center;
  }

  .customizer-loaded .product-container .product-scene .customizer-canvas-wrapper .product-plus-sign {
    opacity: 1;
    visibility: visible;
  }
  .customizer-step-2{
    .product-container .product-scene .customizer-canvas-wrapper .product-plus-sign{
      opacity: 0 !important;
      visibility: hidden !important;
    }
  }

  .product-container .product-scene .product-label .label-customizer-wrapper .blank-canvas-placeholder {
    .upload-title {
      font-size: 24px;
    }
    .upload-info {
      font-size: 14px;
    }
  }

  .product-container .product-scene .slider-wrapper {
    width: calc(100% - 60px);
  }

}

@media screen and (max-width: 375px) {
  .product-container .product-scene .product-label .push-up {
    top: 20px;
  }

  .product-container .product-scene .product-preview .small-button:last-of-type,
  .product-container .product-scene .product-button-wrapper .small-button:last-of-type {
    margin-top: 10px;
  }

  .product-container .product-scene .slider-wrapper {
    margin-top: 10px;
  }
}
